> For the complete documentation index, see [llms.txt](https://uci.sunbird.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://uci.sunbird.org/use/developer/uci-basics/transformers/odk-transformer/interactive-messages.md).

# Interactive-Messages

## Interactive Messaging

The Interactive Message Templates feature allows you to add buttons in message templates that can be used with List and Quick Replies. Buttons will give the ability to develop interactive experiences with pre-set options for users.\
There are two types of buttons:

### 1. List Message

List messages provide a simpler and more consistent format than text-based lists for people to find and select\
List messages are a way to allow users to easily choose from up to 10 options.

#### 1.1 Steps for creating List Message

For sending a List Message, add following properties in ODK form :

* **type** : `select_one <field_name>`\
  Column *type* describes the property of any particular message.
* **name** : `<field_name>`\
  Column *name* refers to unique *field\_name* of any message.
* **label** : `<text>`\
  In label, we can write text content that we want to send to user, If there are any choices available for say *select one field*, the choices will be appended with this text content.
* **bind::stylingTags** : `list`\
  Bind tag indicates, how a *select choice* option should be displayed to user as list or buttons. It is also used to define the media type a message.
* For creating options as list items we have to add the items in the *choices* tab as we do for the *select choices*. These are the properties that needs to be set:
  * **list name** : `<field_name>`\
    In list name, we write the field name, same as we wrote in the *name* field of survey tab.
  * **name** : `<indexing>`\
    In name field, we write index of a list item.
  * **label** : `<title>`\
    In label, we can write the title of a list item, which will be shown to the user.

#### 1.2 Rules for creating List Message

* In a single List Message maximum 10 list items are allowed.
* Maximum 24 characters are allowed in list item label.
* Alphanumeric characters and Spaces are allowed in list item label.

#### 1.3 Example for ODK form of List Message

* Survey Tab&#x20;

![](/files/9a8uRDwb0bA8IH2IYAAj)

* Choices Tab&#x20;

![](/files/rQ5peEnDX21c9CI3l4B7)

#### 1.4 Example of List Message Preview

![](/files/kS6MBtXQDNa7lYeTWy5j)

### 2. Quick Reply Button

These quick reply buttons will help improve the quality of conversations with users by prompting responses that can reduce spelling errors and improve an automated experience.\
These buttons can be attached to text messages and a maximum of 3 Buttons are allowed in one Message.

#### 2.1 Steps for creating Quick Reply Button

To send Quick Reply Button follow the below steps while creating ODK form :

* **type** : `select_one <field_name>`\
  Column *type* describes the property of any particular message.
* **name** : `<field_name>`\
  Column *name* refers to unique *field\_name* of any message.
* **label** : `<text>`\
  In label, we can write text content that we want to send to user, If there are any choices available for say *select one field*, the choices will be appended with this text content.
* **bind::stylingTags** : `buttonsForListItems`\
  Bind tag indicates, how a select choice option should be displayed to user as list or buttons. It is also used to define the media type a message.
* For creating buttons for quick reply, we have to add the items in the choices tab as we do for the select choices. These are the properties that needs to be set:
  * **list name** : `<field_name>`\
    In list name, we write the field name, same as we wrote in the *name* field of survey tab.
  * **name** : `<indexing>`\
    In name field, we write index of a list item.
  * **label** : `<title>`\
    In label, we can write the title of a button, which will be shown to the user.

#### 2.2 Rules for creating Quick Reply Buttons

* In a single Quick Reply Message, maximum 3 buttons are allowed.
* Maximum 20 characters are allowed in button label.
* Alphanumeric characters and Spaces are allowed in button label.

#### 2.3 Example for ODK form of Quick Reply Button

* Survey Tab&#x20;

![](/files/BXCpA96mZCnOFrHAp684)

* Choices Tab&#x20;

![](/files/KTZGFvrmdJSzuxk5ToEt)

#### 2.4 Example of Quick Reply Button Preview

![](/files/MG2JuZFUbJ6mKX3DVfRw)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://uci.sunbird.org/use/developer/uci-basics/transformers/odk-transformer/interactive-messages.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
